%% script2


%%

clear
close all
load filelist

%%

k1 = 4;
file1 = files{k1};
rgb = imread(file1);


%%


% imshow(rgb);
% pt1 = ginput(1);


%%


% pt2 = ginput(1);


%%


% pt3 = ginput(1);


%%


% pt4 = ginput(1);


%%


% gpts = [pt1;pt2;pt3;pt4]
% save script2 gpts
load script2


%%


imshow(rgb);
hold on
plot(gpts(:,1),gpts(:,2),'y','LineWidth',2);
hold off


%%


load tform
[x, y] = transformPointsForward(tf, gpts(:,1),gpts(:,2));
x = x/20/12;
y = y/20/12;
[x y]
plot(x(1:4),y(1:4),'k','LineWidth',2);
axis ij
axis equal
grid

kv1 = [x(2)-x(1) y(2)-y(1)];
kv2 = [x(4)-x(3) y(4)-y(3)];
dist(1) = norm(kv1);
dist(2) = norm(kv2);
kv1 = kv1/dist(1);
kv2 = kv2/dist(2);
phi1 = atan2(kv1(2),kv1(1))*180/pi
phi2 = atan2(kv2(2),kv2(1))*180/pi
theta = phi2 - phi1

D = det([kv1; kv2]);
theta = asin(D)*180/pi;
fprintf('theta %g deg\n',theta);

kp = [-kv1(2) kv1(1)];
p = [x(4)-x(1) y(4)-y(1)];
kp*p'


dist

%%


sz = size(rgb);
nx = sz(2);
ny = sz(1);
cc = [nx ny]/2;
fc = 6600;

pts = (gpts - ones(4,1)*cc)/fc


%%


hpts = e2h(gpts');

% R = [vi; vj; vk]
%R = eye(3);
phi = 81.5;
phit = phi*pi/180;

R = [ 1 0 0; 0 cos(phit) -sin(phit); 0 sin(phit) cos(phit) ]

KK = eye(3);
KK = [ fc 0 cc(1); 0 fc cc(2); 0 0 1];
T1 = R*inv(KK);

% cp = mean(pts,2);
% newcp = h2e(T1*e2h(cp))

newcp = [0 0]';

scl =3.82*10;
M = [scl 0 0; 0 scl 0; 0 0 1]*[eye(2,2) -newcp ;  0 0 1];
T = M*T1;

newpts = h2e(T*hpts)

plot([newpts(1,:) newpts(1,1)],[newpts(2,:) newpts(2,1)],'k');
axis ij
axis equal

%%

x = newpts(1,:);
y = newpts(2,:);

kv1 = [x(2)-x(1) y(2)-y(1)];
kv2 = [x(3)-x(4) y(3)-y(4)];
dist(1) = norm(kv1);
dist(2) = norm(kv2);
kv1 = kv1/dist(1);
kv2 = kv2/dist(2);
phi1 = atan2(kv1(2),kv1(1))*180/pi
phi2 = atan2(kv2(2),kv2(1))*180/pi
theta = phi2 - phi1

D = det([kv1; kv2]);
theta = asin(D)*180/pi;
fprintf('theta %g deg\n',theta);

kp = [-kv1(2) kv1(1)];
p = [x(4)-x(1) y(4)-y(1)];
kp*p'

dist

%%


t = maketform('projective',T');

t.tdata.T

[U V] = tformfwd(t,gpts(:,1),gpts(:,2))
% [out, XData, YData] = imtransform(rgb,t);
out = imtransform(rgb,t,'XData',[-100 100],'YData',[-1200 0]);
% out = imtransform(rgb,t,'XData',[-500 500],'Data',[-500 500],'XYScale',1);
imshow(out);
hold on
plot(U+100,V+1200,'y','LineWidth',2);
hold off

%%


plot(U,V,'k','LineWidth',2);
axis ij
axis equal

%%

tf2 = t;
save script2 gpts tf2 phi


%%

tf3 = projective2d(T');

[U2, V2] = transformPointsForward(tf3, gpts(:,1), gpts(:,2));

norm([U2-U V2-V])

imageSize = [2400 400];
xWorldLimits = [-100 100];
yWorldLimits = [-1200 0];
ref = imref2d(imageSize,xWorldLimits,yWorldLimits);
ref
out = imwarp(rgb,tf3,'OutputView',ref);
imshow(out);
[x, y] = transform_to_warp(tf3,ref,gpts(:,1), gpts(:,2));
hold on
plot(x,y,'y','LineWidth',2);
hold off

%%


file2 = files{1};
rgb2 = imread(file2);

imageSize = [400 400];
xWorldLimits = [-100 100];
yWorldLimits = [-300 -100];
ref2 = imref2d(imageSize,xWorldLimits,yWorldLimits);
ref2
out = imwarp(rgb2,tf3,'OutputView',ref2);
imshow(out);

%%

imageSize = [400 400];
xWorldLimits = [10 50];
yWorldLimits = [-150 -110];
ref3 = imref2d(imageSize,xWorldLimits,yWorldLimits);
ref3
out = imwarp(rgb2,tf3,'OutputView',ref3);
imshow(out);


%%


filename = files{12};
rgb3 = imread(filename);
figure(1);
imshow(rgb3);

imageSize = [800 800];
xWorldLimits = [-80 80];
yWorldLimits = [-260 -100];
ref = imref2d(imageSize,xWorldLimits,yWorldLimits);
ref
out = imwarp(rgb3,tf3,'OutputView',ref);
figure(2);
imshow(out);







